	opt	c-
	
	section prg,code_c
;	include "sources:1994/short_registers.s"
;	include "sources:1994/exec_lib.i"

;*************** PARAMETRES DE L'ECRAN ***************

nbplane=4
size_X=640
size_Y=400

start_X=129				;depart horizontal du trac
start_Y=45				;depart vertical du trac

trace_X=640				;largeur de l'image a tracer  ...
					;... partir de start_X

display_X=640				;largeur de l'image a visualiser  ...
					;... partir de startdisplay_X
display_Y=200				;hauteur de l'image a visualiser  ...
					;... partir de starty

startdisplay_X=129			;debut horizontal visible de l'image

stop_X=display_X/2+startdisplay_X-256	;fin horizontale visible de l'image 
stop_Y=display_Y+start_Y-256		;fin verticale visible de l'image

ddf_strt=(start_X-9)/2 
ddf_stop=ddf_strt+(trace_X/4-8)

modulo_pair=(size_X-trace_X)/8+size_X/8
modulo_impair=(size_X-trace_X)/8+size_X/8

planesize=size_Y*size_X/8

;*************** CONSTANTES ***************

;----- divers -----

execbase=$4
memory=2+$10000
copsize=16*4+11*4+8*nbplane+8+8+4
scroll_speed=2
scroll_Y=380
scroll_X=176
scroll_DX=288+16
nb_points=20
nb_lines=20
speed_Z=2
center_X=464
center_Y=100
size2D=176

;8*4 (palette)
;10*4 (parametres ecran)
;8*nbplane (adresses bitplanes)
;8 (wait+changement $0186)
;8 (adresse copperlist)
;4 (FFFFFFFE)

;*************** MACROS ***************

;----- attente blitter -----

WaitBlit:	macro
Wait_Blit\@
		btst #14,dmaconr(a5)
		bne Wait_Blit\@
		endm

;----- attente VBL -----

WaitVBL:	macro
Wait_VBL\@
		cmp.b #$FF,vhposr(a5)
		bne Wait_VBL\@
		endm

;----- attente reelle VBL -----

WaitRealVBL:	macro
Wait_1stVBL\@
		cmp.b #$FF,vhposr(a5)
		bne Wait_1stVBL\@
Wait_2ndVBL\@
		cmp.b #$FE,vhposr(a5)
		bne Wait_2ndVBL\@
		endm

;*************** PROGRAMME PRINCIPAL ***************

	bsr.w Init

;----- texte -----

	lea pic_adr(pc),a0
	lea text_adr(pc),a1
	lea font_adr(pc),a2
	bsr Printer

	lea pic_adr(pc),a0
	add.l #150*size_X/8+392/8,a0
	lea wishes_adr(pc),a1
	lea font_adr(pc),a2
	bsr Printer

	lea $DFF000,a5

	move.w #%0000010100110011,bltcon0(a5)
	move.w #$2000,bltcon1(a5)
	lea pic_adr(pc),a0
	add.l #150*size_X/8+384/8,a0
	move.l a0,bltbpth(a5)
	add.l #2*size_X/8+planesize,a0
	move.l a0,bltdpth(a5)
	move.w #size_X/8-22,bltdmod(a5)
	move.w #size_X/8-22,bltbmod(a5)
	move.w #11+64*18*8,bltsize(a5)
	waitblit

;----- initialisations -----

Main:
	lea Main(pc),a6
	move.w #360-2*speed_Z,angle_Z-Main(a6)
	lea scrl_adr(pc),a1
	moveq #0,d7

;----- programme principal -----

Main_Loop:
	waitvbl

;----- efface la 2D -----

;la 2D se tient dans un carre de 112 de cote

	WaitBlit
	move.w #(size_X-size2D)/8,bltdmod(a5)
	move.w #0,bltcon1(a5)
	move.w #%0000000111001100,bltcon0(a5)
	move.w #$0000,bltbdat(a5)
	lea pic_adr(pc),a0
	add.l #2*planesize+(center_Y-size2D/2)*size_X/8+(center_X-size2D/2)/8,a0
	move.l a0,bltdpth(a5)
	move.w #size2D/16+size2D*64,bltsize(a5)

;----- text du scroll ------

	dbf d7,Main_NoScroll
	moveq #8/scroll_speed-1,d7
	cmp.b #$1B,(a1)
	beq Main_ScrollEnd
Main_Scroll:
	moveq #0,d0
	move.b (a1)+,d0
	subi.b #$20,d0
	lsl.w #3,d0
	movea.l scroll_adr(pc),a0
	lea scroll_DX/8-1(a0),a0
	lea font_adr(pc),a2
	lea (a2,d0.w),a2
	rept 8
	move.b (a2)+,(a0)
	lea scroll_DX/8(a0),a0
	endr
	bra Main_NoScroll
Main_ScrollEnd:
	lea scrl_adr(pc),a1
	bra Main_Scroll
Main_NoScroll:

;----- scroll -----

	WaitBlit
	move.w #%0000010111001100,bltcon0(a5)
	move.w #0,bltdmod(a5)
	move.w #0,bltbmod(a5)
	move.w #scroll_speed,d0
	ror.w #4,d0
	bset #1,d0
	move.w d0,bltcon1(a5)
	movea.l scroll_adr(pc),a0
	lea 8*scroll_DX/8-2(a0),a0
	move.l a0,bltbpth(a5)
	move.l a0,bltdpth(a5)
	move.w #scroll_DX/16+64*8,bltsize(a5)
	WaitBlit

;----- recopie du scroll -----

	move.w #%0000010111001100,bltcon0(a5)
	move.w #$0000,bltcon1(a5)
	move.w #2,bltbmod(a5)
	move.w #(size_X-scroll_DX)/8+2,bltdmod(a5)
	move.l scroll_adr(pc),bltbpth(a5)
	lea pic_adr(pc),a0
	add.l #scroll_Y*size_X/8+scroll_X/8,a0
	move.l a0,bltdpth(a5)
	move.w #(scroll_DX-16)/16+64*8,bltsize(a5)
	WaitBlit

;----- rotation Z -----

	move.w angle_Z(pc),d0
	sub.w #2*speed_Z,d0
	bge Main_RotationZ
	move.w #360*2-2*speed_Z,d0
Main_RotationZ:
	move.w d0,angle_Z-Main(a6)

;----- calcul des coordonnees -----

	movea.l coor2D_adr(pc),a0
	lea points(pc),a2
	lea cosinus(pc),a3
	lea sinus(pc),a4
	lea (a3,d0.w),a3
	lea (a4,d0.w),a4
	rept nb_points
	move.w (a2)+,d0
	move.w (a2)+,d1
	bsr Rotate_Z
	add.w #center_X,d0
	move.w d0,(a0)+
	add.w #center_Y,d1
	move.w d1,(a0)+
	endr

;----- trace les lignes -----

	move.w #size_X/8,bltcmod(a5)
	move.w #size_X/8,bltdmod(a5)
	move.w #$8000,bltafwm(a5)
	move.w #$8000,bltadat(a5)
	move.w #$FFFF,bltbdat(a5)	;motif droite
	movea.l coor2D_adr(pc),a3
	lea lines(pc),a2
	lea pic_adr(pc),a0
	add.l #2*planesize,a0
	rept nb_lines
	move.w (a2)+,d0
	move.w 2(a3,d0.w),d1
	move.w (a3,d0.w),d0
	move.w (a2)+,d2
	move.w 2(a3,d2.w),d3
	move.w (a3,d2.w),d2
	bsr DrawLine
	endr

;----- remplissage de surface -----

	WaitBlit
	move.w #(size_X-size2D)/8,bltbmod(a5)
	move.w #(size_X-size2D)/8,bltdmod(a5)
	move.w #%0000010111001100,bltcon0(a5)
	move.w #%0000000000001010,bltcon1(a5)
	lea pic_adr(pc),a0
	add.l #2*planesize+(center_Y+size2D/2)*size_X/8-(size_X-center_X-size2D/2)/8,a0
	move.l a0,bltbpth(a5)
	move.l a0,bltdpth(a5)
	move.w #size2D/16+size2D*64,bltsize(a5)

;----- test de fin -----

	btst #6,$bfe001
	bne main_loop

;----- fin -----

	WaitBlit
	bsr fin
	rts

;*************** PRINTER ***************

;Entree:
;	A0=adresse screen
;	A1=adresse texte
;	A2=adresse font

Printer:

	movea.l a0,a3
Printer_Loop:
	moveq #0,d0
	move.b (a1)+,d0
	cmp.w #$20,d0
	beq Printer_Next
	cmp.b #$0A,d0			;fin de ligne ?
	beq Printer_EOL
	cmp.b #$1B,d0			;fin de page ?
	beq Printer_EOP
	subi.b #$20,d0
	lsl.w #3,d0
	movea.l a3,a5
	lea (a2,d0.w),a4
	rept 8
	move.b (a4)+,(a5)
	lea size_X/8(a5),a5
	endr
Printer_Next:
	addq.w #1,a3			;caractere suivant
	bra Printer_Loop
Printer_EOL:
	lea 8*size_X/8(a0),a0		;passe a la ligne
	movea.l a0,a3
	bra Printer_Loop
Printer_EOP:
	addq.w #1,a1			;avale le return apres le $1B

	rts

;*************** ROTATE Z ***************

;Entree:
;	D0=X
;	D1=Y
;	D2=angle Z

Rotate_Z:
	move.w (a3),d4		;d4=cosZ
	swap d4
	move.w (a4),d4		;d4=cosZ:sinZ

	move.w d0,d2		;d2=x
	muls d4,d0
	swap d0
	rol.l #1,d0		;d0=xsinZ
	move.w d1,d3
	muls d4,d3
	swap d3
	rol.l #1,d3		;d3=ysinZ

	swap d4			;d4=sinZ:cosZ

	muls d4,d2		
	swap d2
	rol.l #1,d2		;d2=xcosZ
	add.w d2,d3		;d3=xcosZ+ysinZ
	muls d4,d1	
	swap d1
	rol.l #1,d1		;d1=ycosZ
	sub.w d0,d1		;d1=ycosZ-xsinZ
	move.w d3,d0		;d0=xcosZ+ysinZ

	rts

;*************** TRACE DE DROITES ***************

;Entree:
;	A0=adresse bitplane
;	D0=Xi
;	D1=Yi
;	D2=Xf
;	D3=Yf

;A4,D5,D6

DrawLine:

;----- ordonnancement des points -----

	cmp.w d1,d3
	beq DrawLine_End
	bge DrawLine_UpDown
	exg d0,d2
	exg d1,d3
DrawLine_UpDown:
	subq.w #1,d3

;------ calcul adresse de depart de la droite -----
	
	moveq #0,d6
	move.w d1,d6
	lsl.l #4,d6
	move.l d6,d5
	lsl.l #2,d5
	add.l d5,d6		;d6=y1*nbre octets par ligne
	add.l a0,d6		;+adresse depart bitplane
	moveq #0,d5
	move.w d0,d5
	lsr.w #3,d5
	bclr #0,d5
	add.l d5,d6		;+x1/8

;----- recherche de l'octant -----

	moveq #0,d5
	sub.w d1,d3	;d3=Dy=y2-y1
	bpl.b Dy_pos
	bset #2,d5
	neg d3
Dy_pos:	
	sub.w d0,d2	;d2=Dx=x2-x1
	bpl.b Dx_pos
	bset #1,d5
	neg d2
Dx_pos:
	cmp.w d3,d2	;Dx-Dy
	bpl.b DxDy_pos
	bset #0,d5
	exg d3,d2	;ainsi d3=Pdelta et d2=Gdelta
DxDy_pos:
	add.w d3,d3	;d3=2*Pdelta

;----- BLTCON0 -----
	
	and.w #$F,d0
	ror.w #4,d0
	or.w #$B4A,d0

;----- BLTCON1 -----

	lea Octant(pc),a4
	move.b (a4,d5.w),d5
	lsl #2,d5
	bset #0,d5
	bset #1,d5

;----- attente blitter -----

	WaitBlit

;----- BLTCON1, BLTBMOD, BLTAPTL, BLTAMOD -----

	move.w d3,bltbmod(a5)
	sub.w d2,d3
	bge.s DrawLine_NoBit
	bset #6,d5
DrawLine_NoBit:
	move.w d3,bltaptl(a5)
	sub.w d2,d3
	move.w d3,bltamod(a5)

;----- BLTSIZE -----

	lsl #6,d2
	add.w #66,d2

;----- lancement blitter -----

	move.w d5,bltcon1(a5)
	move.w d0,bltcon0(a5)
	move.l d6,bltcpth(a5)
	move.l d6,bltdpth(a5)
	move.w d2,bltsize(a5)

;----- fin -----

DrawLine_End:

	rts

;*************** INITIALISATION ***************

Init:
	lea Init(pc),a5

;----- reservation de la memoire copperlist 0 -----

	move.l #copsize,d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,cop0_adr-Init(a5)

;----- reservation de la memoire copperlist 1 -----

	move.l #copsize,d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,cop1_adr-Init(a5)

;----- reservation de la memoire scroll -----

	move.l #8*scroll_DX/8,d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,scroll_adr-Init(a5)

;----- reservation de la memoire coordonnees 2D -----

	move.l #4*nb_points,d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,coor2D_adr-Init(a5)

;----- creation de la copperlist 0 -----

	movea.l cop0_adr(pc),a0

	move.l #$01800000,(a0)+
	move.l #$01820FFF,(a0)+
	move.l #$01840E0E,(a0)+
	move.l #$01860FFF,(a0)+
	move.l #$01880EC0,(a0)+
	move.l #$018A0EC0,(a0)+
	move.l #$018C0EC0,(a0)+
	move.l #$018E0EC0,(a0)+
	move.l #$01900000,(a0)+
	move.l #$01920000,(a0)+
	move.l #$01940000,(a0)+
	move.l #$01960000,(a0)+
	move.l #$01980EC0,(a0)+
	move.l #$019A0EC0,(a0)+
	move.l #$019C0EC0,(a0)+
	move.l #$019E0EC0,(a0)+

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #start_Y*256+startdisplay_X,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stop_Y*256+stop_X,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #nbplane,d0
	ror.w #4,d0
	bset #9,d0
	bset #15,d0
	bset #2,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair,(a0)+
	move.l #$01FC0000,(a0)+
	move.l #$01060000,(a0)+

	lea pic_adr(pc),a1
	move.l a1,d1
	move.w #$E0,d0
	rept nbplane-1
	move.w d0,(a0)+
	addq.w #2,d0
	swap d1
	move.w d1,(a0)+
	move.w d0,(a0)+
	addq.w #2,d0
	swap d1
	move.w d1,(a0)+
	add.l #planesize,d1
	endr

	sub.l #planesize+8*size_X/8,d1
	move.w d0,(a0)+
	addq.w #2,d0
	swap d1
	move.w d1,(a0)+
	move.w d0,(a0)+
	swap d1
	move.w d1,(a0)+

	move.w #start_Y+147,d0
	lsl.w #8,d0
	move.b #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01860D0E,(a0)+

	move.l cop1_adr(pc),d0
	move.w #$0082,(a0)+
	move.w d0,(a0)+
	swap d0
	move.w #$0080,(a0)+
	move.w d0,(a0)+

	move.l #$FFFFFFFE,(a0)

;----- creation de la copperlist 1 -----

	movea.l cop1_adr(pc),a0

	move.l #$01800000,(a0)+
	move.l #$01820FFF,(a0)+
	move.l #$01840E0E,(a0)+
	move.l #$01860FFF,(a0)+
	move.l #$01880EC0,(a0)+
	move.l #$018A0EC0,(a0)+
	move.l #$018C0EC0,(a0)+
	move.l #$018E0EC0,(a0)+
	move.l #$01900000,(a0)+
	move.l #$01920000,(a0)+
	move.l #$01940000,(a0)+
	move.l #$01960000,(a0)+
	move.l #$01980EC0,(a0)+
	move.l #$019A0EC0,(a0)+
	move.l #$019C0EC0,(a0)+
	move.l #$019E0EC0,(a0)+

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #start_Y*256+startdisplay_X,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stop_Y*256+stop_X,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #nbplane,d0
	ror.w #4,d0
	bset #9,d0
	bset #15,d0
	bset #2,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair,(a0)+
	move.l #$01FC0000,(a0)+
	move.l #$01060000,(a0)+

	lea size_X/8+pic_adr(pc),a1
	move.l a1,d1
	move.w #$E0,d0
	rept nbplane-1
	move.w d0,(a0)+
	addq.w #2,d0
	swap d1
	move.w d1,(a0)+
	move.w d0,(a0)+
	addq.w #2,d0
	swap d1
	move.w d1,(a0)+
	add.l #planesize,d1
	endr

	sub.l #planesize+8*size_X/8,d1
	move.w d0,(a0)+
	addq.w #2,d0
	swap d1
	move.w d1,(a0)+
	move.w d0,(a0)+
	swap d1
	move.w d1,(a0)+

	move.w #start_Y+147,d0
	lsl.w #8,d0
	move.b #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01860D0E,(a0)+

	move.l cop0_adr(pc),d0
	move.w #$0082,(a0)+
	move.w d0,(a0)+
	swap d0
	move.w #$0080,(a0)+
	move.w d0,(a0)+

	move.l #$FFFFFFFE,(a0)

;----- forbid -----

	CALLEXEC Forbid

;----- modif DMA,... -----

	lea $DFF000,a5
	lea Init(pc),a4
	move.w dmaconr(a5),dmacon_bak-Init(a4)
	move.w intenar(a5),intena_bak-Init(a4)
	move.w #$7FFF,intena(a5)
	move.w #$7FFF,intreq(a5)
	move.w #$7FFF,dmacon(a5)
	move.w #$2E-1,d0
	lea $8,a0
	lea vectors_bak(pc),a1
	lea vectors_end(pc),a2
Init_VecLoop:
	move.l (a0),(a1)+
	move.l a2,(a0)+
	dbf d0,Init_VecLoop
	move.l cop0_adr(pc),cop1lch(a5)
	clr.w copjmp1(a5)
	move.w #$8000,vposw(a5)
	move.w #$87C0,dmacon(a5)	;COPEN, BPLEN, BLTPRI, DMAEN

	rts

;*************** FIN DE PROGRAMME ***************

Fin:

;----- restauration des canaux DMA, ... ----

	move.w #$2E-1,d0
	lea vectors_bak(pc),a0
	lea $8,a1
Fin_VecLoop:
	move.l (a0)+,(a1)+
	dbf d0,Fin_VecLoop
	move.w dmacon_bak(pc),d0
	bset #15,d0
	move.w d0,dmacon(a5)
	move.w intena_bak(pc),d0
	bset #15,d0
	move.w d0,intena(a5)

;----- permit -----

	CALLEXEC Permit

;----- liberation memoire copperlist 0 -----

	movea.l cop0_adr(pc),a1
	move.l #copsize,d0
	CALLEXEC FreeMem

;----- liberation memoire copperlist 1 -----

	movea.l cop1_adr(pc),a1
	move.l #copsize,d0
	CALLEXEC FreeMem

;----- liberation memoire scroll -----

	movea.l scroll_adr(pc),a1
	move.l #8*scroll_DX/8,d0
	CALLEXEC FreeMem

;----- liberation memoire coordonnees 2D -----

	movea.l coor2D_adr(pc),a1
	move.l #4*nb_points,d0
	CALLEXEC FreeMem

;----- restaurer la copperlist dos -----

	lea gfx_name(pc),a1
	CALLEXEC OldOpenLibrary
	move.l d0,a1
	move.l 38(a1),cop1lch(a5)
	clr.w copjmp1(a5)
	CALLEXEC CloseLibrary

	rts

;*************** VARIABLES ***************

vectors_end:	rte
vectors_bak:	dcb.l $2E
dmacon_bak:	dc.w 0
intena_bak:	dc.w 0
angle_Z:	dc.w 0
cop0_adr:	dc.l 0
cop1_adr:	dc.l 0
scroll_adr:	dc.l 0
coor2D_adr:	dc.l 0
gfx_name:	dc.b "graphics.library",0
	even
wishes_adr:	incbin "1994-list.txt"
	even
text_adr:	incbin "1994.txt"
	even
scrl_adr:	incbin "1994.scrl"
	even
font_adr:	incbin "logo.fnt"

points:
	dc.w 0,-70
	dc.w 67,-22
	dc.w 41,57
	dc.w -41,57
	dc.w -67,-22
	dc.w 0,40
	dc.w 38,12
	dc.w 24,-32
	dc.w -24,-32
	dc.w -38,12

	dc.w 0,-50
	dc.w 48,-15
	dc.w 29,40
	dc.w -29,40
	dc.w -48,-15
	dc.w 0,26
	dc.w 25,8
	dc.w 15,-21
	dc.w -15,-21
	dc.w -25,8

lines:
	dc.w 0*4,7*4
	dc.w 7*4,1*4
	dc.w 1*4,6*4
	dc.w 6*4,2*4
	dc.w 2*4,5*4
	dc.w 5*4,3*4
	dc.w 3*4,9*4
	dc.w 9*4,4*4
	dc.w 4*4,8*4
	dc.w 8*4,0*4

	dc.w 10*4,17*4
	dc.w 17*4,11*4
	dc.w 11*4,16*4
	dc.w 16*4,12*4
	dc.w 12*4,15*4
	dc.w 15*4,13*4
	dc.w 13*4,19*4
	dc.w 19*4,14*4
	dc.w 14*4,18*4
	dc.w 18*4,10*4

sinus:
	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763,32767

	dc.w 32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

cosinus:
	dc.w 32767,32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763

;table des octants: y2-y1,x2-x1,Dx-Dy
;si <0 alors 0 si >=0 alors 1. Par exemple: 
;	y2-y1<0 	donc 1
;	x2-x1<0 	donc 1
;	Dx-Dy<0		donc 1
;le code octant est donc le .b qui se trouve a l'adresse octant+111

octant:
	dc.b 4	;000 y1<y2 x1<x2 Dx>Dy
	dc.b 0	;001 y1<y2 x1<x2 Dx<Dy
	dc.b 5	;010 y1<y2 x1>x2 Dx>Dy
	dc.b 2	;011 y1<y2 x1>x2 Dx<Dy
	dc.b 6	;100 y1>y2 x1<x2 Dx>Dy
	dc.b 1	;101 y1>y2 x1<x2 Dx<Dy
	dc.b 7	;110 y1>y2 x1>x2 Dx>Dy
	dc.b 3	;111 y1>y2 x1>x2 Dx<Dy
	even

pic_adr:	incbin "1994-background.raw"
